<template>
  <div class="fixed-tarif">
    <i
      v-if="price"
      class="icon lock price-locked"
      :class="{'price-unlocked': !fixedPriceCurrently}"
      @click.stop="toggleFixedPrice"></i>

    <div class="fixed-tarif-input-wrapper">
      <ObInput
          v-model="localPrice"
          type="money:2"
          data-qa="fixedPriceInputBP"
          @change="updateFixedPrice()"
      />
    </div>
    <span class="price__km-currency">₽</span>
  </div>
</template>
<script>

import api from '@/api';
import ObInput from 'common-components/src/obComponents/obInput';
import numberWithSpaces from '@/utils/formatNumber';

export default {
  name: 'FixedPriceView',
  components: {
    ObInput,
  },
  props: {
    fixedPriceCurrently: {
      type: Boolean,
      default: () => false
    },
    price: {
      type: Object,
      default: () => {}
    },
    departureUuid: {
      type: String,
      default: () => ''
    },
    arrivalUuid: {
      type: String,
      default: () => ''
    },
    resourceUuid: {
      type: String,
      default: () => ''
    },
  },
  data() {
    return {
      localPrice: this.price?.priceKm ?? 0,
    }
  },
  methods: {
    priceFormat(value, divider = 100) {
      return numberWithSpaces(value, divider).replace('.', ',');
    },
    async toggleFixedPrice(){
      if(this.fixedPriceCurrently || this.localPrice <= 0) {
        await this.updateFixedPrice(true);
      } else {
        await this.updateFixedPrice();
      }
    },
    async updateFixedPrice(del = false) {
        try {
          if( this.localPrice > 0 && !del ) {
            await api.base_prices.updateFixedPrice(
                this.departureUuid,
                this.arrivalUuid,
                this.resourceUuid,
                {
                  price_stage: this.localPrice,
                  distance: 1,
                  price_km: this.localPrice,
                }
            );
          } else {
            await api.base_prices.deleteFixedPrice(
                this.departureUuid,
                this.arrivalUuid,
                this.resourceUuid,
            );
          }
          this.$emit('update');
          this.$notification({
            type: 'system_notification_success',
            message: `Сохранено`,
          });

        } catch {
          this.$notification({
            type: 'system_notification_error',
            message: 'Ошибка сохранения',
          });
        }
    }
  }
}
</script>
<style lang="scss" scoped>
@import "~common-components/src/static/css/mixins";

.fixed-tarif{
  display: flex;
  align-items: center;

  .icon.lock{
    font-size: 25px;
    margin-right: 15px;
    cursor: pointer;
    &.price-locked{
      color: $light-raspberry-red;
    }
    &.price-unlocked {
      color: #dedede;
    }
  }

  .price__km-currency{
    font-size: 12px;
    color: $gray-slate;
    flex: none;
  }

  &::v-deep {

    .ob-input-wrap{
      padding-right: 5px;
    }

    .input-group .input{
      text-align: right;
    }

    .fixed-tarif-input-wrapper{
      width: 100%;

      &:not(:hover) {
        .ob-input-container .ob-input-wrap{
          background: transparent;
          border-color: transparent;
        }
      }
    }

  }
}




</style>
